***********************************************************
*   Procedure:  D_BROWSE                                  *
*                                                         *
*   Author:     Gary Light                                *
*               GLI Information Systems                   *
*                                                         *
*   Date:       July 15, 1990                             *
*                                                         *
*   Purpose:    This process invokes the UDF "BROWSER"    *
*               and demonstrates how to use it in a       *
*               program.                                  *
*               It also functions as a full featured      *
*               database browse program.                  *
***********************************************************

SET EXCLUSIVE OFF
SETBOX = .T.
BXTOP = 0
BXBOT = 0
BXLEFT= 0
BXRIGHT = 0


* status flags *
SET SCOREBOARD OFF
SET WRAP OFF
SET CONFIRM ON

* default color set *
IF ISCOLOR()
   * defaults for color monitor *
   c_MAIN    = "N/BG,R+/W,BG"
   c_MENU    = "W+/B,G+/GR"
   c_POPUP   = "W/R,N/GR"
   c_GETS    = "G+/GR"
   c_INVERSE = "N/R"
   c_special = "N/RB"
ELSE
   * monochrome colors *
   c_MAIN    = "W/N,N/W,N"
   c_MENU    = "W/N,N/W,N"
   c_POPUP   = "W/N,N/W,N"
   c_GETS    = "N/W"
   c_INVERSE = "N/W"
   c_SPECIAL = "N/W"
ENDIF

SET COLOR TO (c_special)
CLEAR

SET COLOR TO (c_MAIN)

DO CENTRLIN WITH "                         ",7
DO CENTRLIN WITH "         BROWSER         ",8
DO CENTRLIN WITH "                         ",9
DO CENTRLIN WITH " GLI Information Systems ",10
DO CENTRLIN WITH "    162 Lawrence Road    ",11
DO CENTRLIN WITH "     Salem, NH 03079     ",12
DO CENTRLIN WITH "      (603)894-4311      ",13
DO CENTRLIN WITH "                         ",14
SHADOW(7,28,14,52)

SET COLOR TO (c_special)

@ 24,1 SAY"Version 3.0"
@ 24,65 SAY"July 15, 1990"

PAUSE(0)
CLEAR

* initilize *
t = 0
l = 0
b = 23
r = 79
u = .t.
h = .t.
s = .t.
flist_m1 = 0

DO WHILE .T.
   db = SPACE(8)
   SET COLOR TO (c_MAIN)
   @ 6,28 CLEAR TO 17,49
   @ 06,28 TO 17,49
   @ 08,29 say"Top      " get t picture "##"
   @ 09,29 say"Left     " get l picture "##"
   @ 10,29 say"Bottom   " get b picture "##"
   @ 11,29 say"Right    " get r picture "##"
   @ 12,29 say"Update   " get u picture "L"
   @ 13,29 say"Boaders  " get h picture "L"
   @ 14,29 SAY"Status   " get s picture "L"
   @ 15,29 SAY"Database " get db picture "!!!!!!!!"
   SET COLOR TO (c_special)
   @ 18,29 say "press <ESC> to stop"
   SET COLOR TO (c_MAIN)
   READ

   IF LASTKEY() = 27
      CLOSE ALL
      EXIT
   ENDIF

   db = alltrim(db)

   * no file, try again *
   IF ! FILE("&db..DBF")

      * esc handler *
      IF LASTKEY() = 27
         EXIT
      ENDIF

      SET COLOR TO (c_special)
      TONE(499,5)
      @ 2,28 SAY "Database file not found!"
      PAUSE(0)

      db = SPACE(8)
      @ 2,28 CLEAR TO 2,55
      LOOP
   ENDIF

   * file found *
   USE &db
   fn = ". "
   I = 0
   begin_spaces = r - l
   curr_spaces = begin_spaces

   DECLARE fldarray[FCOUNT()+10], fldlist[FCOUNT()+1], dummy[1]
   AFILL(fldarray,"")

   FOR I = 1 TO FCOUNT()
      fldlist[I] = SUBSTR(FIELD(I)+SPACE(14),1,14)+STR(FIELD_LEN(FIELD(I)),3)
   NEXT

   fldlist[FCOUNT()+1] = " ---  done  --- "

   SAVE SCREEN TO d_browse_s1

   I = 0

   @ 6,59 CLEAR TO 8,75

   * get a list of field names *
   DO WHILE fn <> "          "
      @  6,60 SAY "Spaces left: "+STR(curr_spaces,2)
      @  7,60 TO 7,74
      I = I + 1
      fn = "          "
      DO FLIST

      IF ! EMPTY(fn)
         fldarray[I] = ALLTRIM(fn)
         curr_spaces = curr_spaces - FIELD_LEN(fn) - 1
         @ 8,60 SAY "Selected fileds:"

         IF I <= 16
            @ 8+I,59 CLEAR TO 8+I,75
            @ 8+I,62 SAY fn
         ENDIF
      ENDIF
   ENDDO

   RESTORE SCREEN FROM d_browse_s1
   fldarray[I] = ""

   ************************
   * These are best declared in the calling routine
   * in order to take full advantage of passing status
   * back and forth. The array REC must be public.
   ************************
   PUBLIC REC[reccount()+25]
   needstore = .t.
   lastrec   = 0
   ************************

   ************************
   *
   *   It is possible to initilize the REC array prior to entering
   *   the browse command. Store the RECNO()'s of the records to browse
   *   in REC[1..lastrec], initilize lastrec to the number of records,
   *   and set needstore to .F.
   *   Hint - Use a routine to store the RECNO()'s such as the generic
   *   FUNCTION initrec listed in this example.
   *
   *   OK = INITREC(name,"=","NAME")
   *   IF OK
   *      BROWSER( ...)
   *   ELSE
   *      NO RECORDS FOUND
   *   ENDIF
   *   needstore would be set false here
   ************************

   * setting needstore TRUE will cause BROWSER to store the locations  *
   * of all records in the database. If you have pre stored REC, or if *
   * you are entering BROWSER on a previously BROWSED database which   *
   * hasn't been altered significantly (append/delete), then you should*
   * set needstore FALSE.                                              *

   needstore = .T.
   BROWSER(T,L,B,R,fldarray,U,H,S)
   CLOSE ALL
ENDDO


**************************************************************************
PROCEDURE FLIST
* this provides a field selection list for the active database  *
* it falls apart alittle with more then 15 fields but it's good *
* enough for this example.                                      *

DUM = ""

@ 6,1 TO 17,19 DOUBLE
@ 7,2 SAY "fld name      len"

flist_m1 = ACHOICE(8,2,16,18,fldlist,dummy,DUM,flist_m1)


* return the field name or blanks *
IF flist_m1 =0 .OR. flist_m1 = FCOUNT()+1
   fn = "          "
ELSE
   fn = FIELD(flist_m1)
ENDIF

RETURN

**************************************************************************
* eof *